'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); // @ts-check


var _helpers = require('./helpers');

var lib = _interopRequireWildcard(_helpers);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var VeasyClass = function () {
  /**
   * Creates an instance of FormValidator.
   * @param {object} component
   * @param {object} schema
   * @memberof VeasyClass
   */
  function VeasyClass(component, schema) {
    _classCallCheck(this, VeasyClass);

    lib.typeCheck(component, schema);
    /** @type { { state:object, setState:Function } } */
    this.component = component;
    this.schema = schema;
  }

  /**
   * Create the initial state for a component
   *
   * @returns {object}
   * @memberof VeasyClass
   */


  _createClass(VeasyClass, [{
    key: 'createInitialState',
    value: function createInitialState(userState) {
      return lib.createInitialState(this.schema, userState);
    }

    /**
     * The validate function, call this in your onChange() handler of the form component
     *
     * @param {object} target
     * @memberof VeasyClass
     */

  }, {
    key: 'validate',
    value: function validate(target) {
      lib.startValidating(target, this.schema, this.component.state, this.component.setState.bind(this.component));
    }
  }, {
    key: 'getFieldsValue',
    value: function getFieldsValue() {
      var mustOK = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      lib.getFieldsValue(this.schema, this.component.state, mustOK);
    }
  }]);

  return VeasyClass;
}();

exports.default = VeasyClass;
//# sourceMappingURL=VeasyClass.js.map