'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helpers = require('./helpers');

var lib = _interopRequireWildcard(_helpers);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable react/forbid-prop-types,import/no-extraneous-dependencies */


var VeasyForm = function (_React$Component) {
  _inherits(VeasyForm, _React$Component);

  function VeasyForm() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, VeasyForm);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = VeasyForm.__proto__ || Object.getPrototypeOf(VeasyForm)).call.apply(_ref, [this].concat(args))), _this), _this.triggerValidation = function (e) {
      e.persist();
      var _this$props = _this.props,
          schema = _this$props.schema,
          allState = _this$props.allState,
          update = _this$props.update;

      lib.startValidating(e.target, schema, update, allState);
    }, _this.handleOnChange = function (e) {
      return _this.triggerValidation(e);
    }, _this.handleBlur = function (e) {
      return _this.triggerValidation(e);
    }, _this.isRegisteredComponent = function (child) {
      // Skip HTML element
      if (_is_js2.default.string(child.type)) return false;

      if (!_is_js2.default.propertyDefined(child.props, 'name')) return false;

      var childName = child.props.name;
      var names = Object.keys(_this.props.schema);
      if (names.includes(childName)) return true;

      return false;
    }, _this.cloneElement = function (child, childName) {
      var childProp = _this.props.allState[childName];
      return _react2.default.cloneElement(child, {
        status: childProp.status,
        errorText: childProp.errorText,
        value: childProp.value,
        onChange: _this.handleOnChange
      });
    }, _this.recursiveCloneChildren = function (children) {
      return _react2.default.Children.map(children, function (child) {
        if (!_react2.default.isValidElement(child)) return child;

        if (_this.isRegisteredComponent(child)) {
          return _this.cloneElement(child, child.props.name);
        }

        if (_is_js2.default.not.propertyDefined(child.props, 'children')) return child;

        var childProps = {};

        // String has no Prop
        childProps.children = _this.recursiveCloneChildren(child.props.children);
        return _react2.default.cloneElement(child, childProps);
      });
    }, _this.handleReset = function (e) {
      e.preventDefault();
      var _this$props2 = _this.props,
          update = _this$props2.update,
          schema = _this$props2.schema,
          allState = _this$props2.allState;

      update(lib.resetForm(schema, allState));
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(VeasyForm, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          schema = _props.schema,
          allState = _props.allState,
          update = _props.update,
          children = _props.children,
          tag = _props.tag,
          reset = _objectWithoutProperties(_props, ['schema', 'allState', 'update', 'children', 'tag']);

      var Component = tag;
      return _react2.default.createElement(
        Component,
        _extends({ onBlur: this.handleBlur, onReset: this.handleReset }, reset),
        this.recursiveCloneChildren(children)
      );
    }
  }]);

  return VeasyForm;
}(_react2.default.Component);

exports.default = VeasyForm;


VeasyForm.defaultProps = {
  allState: undefined,
  tag: 'form'
};

VeasyForm.propTypes = {
  schema: _propTypes2.default.object.isRequired,
  allState: _propTypes2.default.object,
  update: _propTypes2.default.func.isRequired,
  tag: _propTypes2.default.string,
  children: _propTypes2.default.any.isRequired
};
//# sourceMappingURL=VeasyForm.js.map