'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.notEndWith = exports.endWith = exports.notStartWith = exports.startWith = exports.exclude = exports.include = exports.maxLength = exports.minLength = undefined;

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var minLength = exports.minLength = function minLength(name, value, schema) {
  return {
    isValid: _is_js2.default.equal(value.length, schema.minLength) || _is_js2.default.above(value.length, schema.minLength),
    errorText: name + '\'s length should be equal or greater than ' + schema.minLength + '. Current: ' + value.length
  };
}; /* eslint-disable max-len */

var maxLength = exports.maxLength = function maxLength(name, value, schema) {
  return {
    isValid: _is_js2.default.equal(value.length, schema.maxLength) || _is_js2.default.under(value.length, schema.maxLength),
    errorText: name + '\'s length should be equal or less than ' + schema.maxLength + '. Current: ' + value.length
  };
};

var include = exports.include = function include(name, value, schema) {
  return {
    isValid: _is_js2.default.include(value, schema.include),
    errorText: name + ' should include ' + schema.include + '. Current: ' + value
  };
};

var exclude = exports.exclude = function exclude(name, value, schema) {
  return {
    isValid: _is_js2.default.not.include(value, schema.exclude),
    errorText: name + ' should not include ' + schema.exclude + '. Current: ' + value
  };
};

var startWith = exports.startWith = function startWith(name, value, schema) {
  return {
    isValid: _is_js2.default.startWith(value, schema.startWith),
    errorText: name + ' should start with \'' + schema.startWith + '\'.'
  };
};

var notStartWith = exports.notStartWith = function notStartWith(name, value, schema) {
  return {
    isValid: _is_js2.default.not.startWith(value, schema.notStartWith),
    errorText: name + ' should not start with \'' + schema.notStartWith + '\'.'
  };
};

var endWith = exports.endWith = function endWith(name, value, schema) {
  return {
    isValid: _is_js2.default.endWith(value, schema.endWith),
    errorText: name + ' should end with \'' + schema.endWith + '\'.'
  };
};

var notEndWith = exports.notEndWith = function notEndWith(name, value, schema) {
  return {
    isValid: _is_js2.default.not.endWith(value, schema.notEndWith),
    errorText: name + ' should not end with \'' + schema.notEndWith + '\'.'
  };
};
//# sourceMappingURL=stringRules.js.map